(* Title:   test/Tools/isac/ADDTESTS/file-depend
   Author:  Walther Neuper 2009
*)

header {* Test file dependencies analogous to ISAC

$ cd /usr/local/isabisac/test/Tools/isac/ADDTESTS/file-depend
$ /usr/local/isabisac/bin/isabelle jedit Build_Test.thy &
*}
(*----------------------------------------------------------------------------
theory Build_Test 
imports 
  Complex_Main 
  "1language/Foo_Language"
  "3knowledge/Foo_KnowALL"
begin
----------------------------------------------------------------------------*)

theory BuildC_Test (*Duplicate theory name
                    {..., Foo_Language, Foo_Know111, Foo_Know222, Foo_KnowALL, Build_Test}
                    {..., Nitpick, Main, testdir1, testdirm, Build_Test}*)
imports 
  Complex_Main 
  "~~/test/Tools/isac/ADDTESTS/file-depend/1language/Foo_Language" 
  "~~/test/Tools/isac/ADDTESTS/file-depend/3knowledge/Foo_KnowALL"
begin
  ML_file "~~/test/Tools/isac/ADDTESTS/file-depend/0foolibrary.ML"                    
    ML {* val Free ("b", _) = foolibrhs  @{term "a = b"} *}
(*use_thy "1language/Foo_Language" --- is done by import above*)        
    ML {* val Const ("Foo_Language.fooprog", _) = @{term fooprog} *}
  ML_file "~~/test/Tools/isac/ADDTESTS/file-depend/2interpreter/2foointerpreter.ML"   
    ML {* val Free ("b", _) = foointerpret @{term "fooprog (a = b)"} *}

text {* the different theories of knowledge are recognized, Const bar*: *}
ML {* 
val trm = Syntax.read_term_global @{theory Foo_Know111} 
  "fooprog (foo111 = bar111)";
val Const ("Foo_Know111.bar111", _) = foointerpret trm;

val trm = Syntax.read_term_global @{theory Foo_Know222} 
  "fooprog (foo222 = bar222)";
val Const ("Foo_Know222.bar222", _) = foointerpret trm;
*}

text {* the different theories of knowledge are recognized, Free bar*: *}
ML {*
val trm = Syntax.read_term_global @{theory Foo_Know111} 
  "fooprog (foo222 = bar222)";
(*Const ("Foo_Language.fooprog", "bool => Foo_Language.foosource") $
     (Const ("HOL.eq", "'a => 'a => bool") $ Free ("foo222", "'a") $
       Free ("bar222", "'a"))
   : term*)

val trm = Syntax.read_term_global @{theory Foo_Know222} 
  "fooprog (foo111 = bar111)";
(*val trm =
   Const ("Foo_Language.fooprog", "bool => Foo_Language.foosource") $
     (Const ("HOL.eq", "'a => 'a => bool") $ Free ("foo111", "'a") $
       Free ("bar111", "'a"))
   : term*)
*}

text {* dir structure reflects ISAC, see Build_Isac.thy:
/file-depend/0foolibrary.ML
/file-depend/Build_Test.thy
/file-depend/README

/file-depend/1language/Foo_Language.thy

/file-depend/2interpreter/2foointerpreter.ML

/file-depend/3knowledge/Foo_Know111.thy
/file-depend/3knowledge/Foo_Know222.thy
/file-depend/3knowledge/Foo_KnowALL.thy
*}

end