(* Title: tests for the interface
   Author: Mathias Lehnfeld 2013
   Use is subject to license terms.
*)

"-----------------------------------------------------------------------------";
"-----------------------------------------------------------------------------";
"table of contents -----------------------------------------------------------";
"-----------------------------------------------------------------------------";
"-------- test_applyFormula --------------------------------------------------";
"-----------------------------------------------------------------------------";
"-----------------------------------------------------------------------------";


"-------- TODO ---------------------------------------------------------------";
"-------- TODO ---------------------------------------------------------------";
"-------- TODO ---------------------------------------------------------------";

"----- this shows the principle how Isac's math-engine is made parallel ------";
(* a store of simplified states *)
val test_states = Unsynchronized.ref ([]: (int * string list) list)

(* a simplified getter *)
fun test_get_calc cI =
  case assoc (!test_states, cI) of
    NONE => error ("get_calc " ^ string_of_int cI ^ " not existent")
  | SOME c => c;

(* a simplified updater *)
fun test_upd_calc cI cs =
  (if is_none (assoc (!test_states, cI))
  then writeln ("upd_calc created new calculation " ^ string_of_int cI)
  else ();
  test_states := overwrite (!test_states, (cI, cs)))

(* a dummy call of the math-engine *)
fun test_math_engine cs = cs |> split_last ||> (fn x => x ^ "-CHECKED") ||> single |-> (curry op @);

test_states :=
  [(1, ["calc1-line1", "calc1-line2", "calc1-line3"]),
  (2, ["calc2-line1"]),
  (3, ["calc3-line1", "calc3-line2"])];
test_states := [];

val cI = 123;
test_upd_calc cI ["initialize 123"];
appendFormula cI;